import React from 'react';
import { Icon, Button, Input, Select, Spin, Table, Switch, message, DatePicker } from 'antd';
import $ from 'jquery/src/ajax';
import moment from 'moment';
import '@/account/demand/techDemand.less';
import NewDesc from '@/administration/video/videoDesc';
import { videoType ,videoStatus} from '@/dataDic.js';
import {getVideoType,getVideoStatus } from '@/tools.js';

const PolicyList = React.createClass({
    loadData(pageNo) {
        this.state.data = [];
        this.setState({
            page:pageNo,
            loading: true
        });
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/video/getVideoList",
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,
                name: this.state.videoName, 
                type: this.state.videoType,
                status:this.state.videoState,
            },
            success: function (data) {
                let theArr = [];
                if (!data.data || !data.data.list) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];
                        theArr.push({
                            key: i,
                            id: thisdata.id,
                            name: thisdata.name,
                            url:globalConfig.videoServer+thisdata.url,
                            type: thisdata.type,
                            owner: thisdata.owner, //审核状态
                            status:thisdata.status,
                            transcoding:thisdata.transcoding,
                            summary:thisdata.summary,
                            createTime:thisdata.createTime?(new Date(thisdata.createTime)).toLocaleString():'',
                            releaseTime:thisdata.releaseTime?(new Date(thisdata.releaseTime)).toLocaleString():''
                        });
                    };
                };
                this.state.selectedRowKeys=[];
                this.state.pagination.current = data.data.pageNo;
                this.state.pagination.total = data.data.totalCount;
                if(data.data&&data.data.list&&!data.data.list.length){
					this.state.pagination.current=0
					this.state.pagination.total=0
				};
                this.setState({
                    dataSource: theArr,
                    pagination: this.state.pagination
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
            searchMore: true,
            releaseDate: [],
            selectedRowKeys: [],
            selectedRows: [],
            loading: false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '视频名称',
                    dataIndex: 'name',
                    key: 'name',
                    render:text=>{
                        return (text&&text.length>10)?text.substr(0,10)+'...':text;
                    }
                },  {
                    title: '视频地址',
                    dataIndex: 'url',
                    key: 'url',
                    
                },
                {
                    title: '视频类型',
                    dataIndex: 'type',
                    key: 'type',
                    render: text => { return getVideoType(text) }
                },
                {
                    title: '上传者',
                    dataIndex: 'owner',
                    key: 'owner',
                    render:text=>{
                        return text==1?'管理员':text
                    }
                },
                {
                    title: '转码状态',
                    dataIndex: 'transcoding',
                    key: 'transcoding',
                    render:text=>{
                        return text==2?'已转码':'正在转码'
                    }
                },
                {
                    title: '发布时间',
                    dataIndex: 'releaseTime',
                    key: 'releaseTime'
                },
                {
                    title: '创建时间',
                    dataIndex: 'createTime',
                    key: 'createTime'
                },
                {
                    title: '状态',
                    dataIndex: 'status',
                    key: 'status',
                    render: text => { return getVideoStatus(text) }
                },
                {
                    title: '操作',
                    dataIndex: 'caozuo',
                    key: 'caozuo',
                    render:(text,recard) => {
                        return  <div className="btnRight">
                                   {((recard.status=='0'||recard.status=='2')&&recard.transcoding=='2')&&<Button type="primary" style={{ background: "#3fcf9e", border: "none", color: "#fff" }} onClick={(e)=>{e.stopPropagation(),this.submission(recard,1)}}>发布</Button>}
                                   {recard.status=='1'&&<Button type="danger" onClick={(e)=>{e.stopPropagation(),this.submission(recard,2)}}>撤销发布</Button>}
                                </div>
                    }
                }
            ],
            dataSource: [],
            searchTime: [,]
        };
    },
    //发布
    submission(record,nub){
        this.setState({
            showDesc:false,
            loading:true
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/video/updateVideo",
            data: {
                id:record.id,
                status:nub
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success(nub=='1'?'发布成功.':'撤销发布');
                this.setState({
                    loading: false,
                });
                this.loadData(this.state.page)
            } else {
                message.warning(data.error[0].message);
            };
        }.bind(this));
    },
    componentWillMount() {
        this.loadData();
    },
    tableRowClick(record, index) {
        this.state.RowData = record;
        this.setState({
            showDesc: true
        });
    },
    delectRow() {
        let deletedIds =[];
        let rowItem = this.state.selectedRowKeys[0];
        let data = this.state.dataSource ||[];
        if (data.length) {
            deletedIds.push(data[rowItem].id);
        }
        if(data[rowItem].status=='1'){
            message.warning('不能删除已发布的视频.')
            return false ;
        }
        this.setState({
            loading:true
        })
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/video/updateVideo",
            data: {
                id: deletedIds[0],
                status:3
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('删除成功！');
                this.setState({
                    loading: false
                });
                if(this.state.pagination.total%10==1){
                    this.loadData((this.state.page)-1);
                }else{
                    this.loadData(this.state.page);
                }
            } else {
                message.warning(data.error[0].message);
                this.setState({
                    loading: false
                });
            };
        }.bind(this));
    },
    addClick() {
        this.state.RowData = {};
        this.setState({
            showDesc: true
        });
    },
    closeDesc(e, s) {
        this.state.showDesc = e;
        if (s) {
            this.loadData(this.state.page);
        };
    },
    search() {
        this.loadData();
    },
    reset() {
        this.state.videoName = '';
        this.state.releaseDate = [];
        this.state.videoType = undefined;
        this.state.videoState = undefined;
        this.loadData();
        
    },
    searchSwitch() {
        this.setState({
            searchMore: !this.state.searchMore
        });
    },
    render() {
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
                this.setState({
                    selectedRows: selectedRows.slice(-1),
                    selectedRowKeys: selectedRowKeys.slice(-1)
                });
            }

        };
        const { RangePicker } = DatePicker;
        const hasSelect = this.state.selectedRowKeys.length;
        return (
            <div className="user-content" >
                <div className="content-title">
                    <span>视频管理</span>
                    <div className="patent-addNew">
                        <Button type="primary" onClick={this.addClick}>新建视频<Icon type="plus" /></Button>
                    </div>
                </div>
                <div className="user-search">
                    <Input placeholder="视频名称"
                        value={this.state.videoName}
                        onChange={(e) => { this.setState({ videoName: e.target.value }); }} />
                    <Select placeholder="视频类型" style={{ width: 120 }}
                        value={this.state.videoType}
                        onChange={(e) => { this.setState({ videoType: e }) }}>
                        {videoType.map(item=>{
                            return <Select.Option value={item.value}>{item.key}</Select.Option>
                        })}
                    </Select>
                    <Select placeholder="视频状态" style={{ width: 120 }}
                        value={this.state.videoState}
                        onChange={(e) => { this.setState({ videoState: e }) }}>
                         {videoStatus.map(item=>{
                            return <Select.Option value={item.value}>{item.key}</Select.Option>
                        })}
                    </Select>
                    <Button type="primary" onClick={this.search}>搜索</Button>
                    <Button onClick={this.reset}>重置</Button>
                    <Button type="danger" disabled={!hasSelect}  onClick={(e)=>{this.delectRow()}}>删除</Button>
                </div>
                <div className="patent-table">
                    <Spin spinning={this.state.loading}>
                        <Table columns={this.state.columns}
                            dataSource={this.state.dataSource}
                            rowSelection={rowSelection}
                            pagination={this.state.pagination}
                            onRowClick={this.tableRowClick} />
                    </Spin>
                </div>
                <NewDesc
                    data={this.state.RowData}
                    showDesc={this.state.showDesc}
                    closeDesc={this.closeDesc} />
            </div >
        );
    }
});

export default PolicyList;